#!/usr/bin/python           # This is server.py file

#Added simple energy depletion check and trying not to shoot the sun with missiles. Just for the sake of participation. Nice framework for the task!

import socket               # Import socket module
import sys
import json
import math
from random import random
from time import sleep

def is_sun_target(y,x,rotation):
    polar_radius = math.sqrt(y**2 + x**2)
    polar_angle = math.atan2(y,x)
    if(polar_angle>=0):
        polar_angle_degrees = 180*polar_angle/math.pi
    else:
        polar_angle_degrees = 360 + 180*polar_angle/math.pi
    #print polar_angle
    #print polar_angle_degrees
    #print rotation

    rotation_back = (rotation+180)%360
    angle_diff = 180 - abs(abs(rotation_back - polar_angle_degrees) - 180) 
    #print angle_diff
    if abs(angle_diff)<10:
        print "Aiming at the sun\n"
        return True

    return False

s = socket.socket()         # Create a socket object
host = socket.gethostname() # Get local machine name
port = 54321                # Reserve a port for your service.

s.connect((host, port))
s.send(b"NAME TRiggerHappy\n")

action_now = int(random()*7)
for line in s.makefile('r'):
    #print line
    j=json.loads(line)
    if j["messagetype"] != "stateupdate":
        continue
    #print j["gamestate"]["others"]

    r = int(random()*7)

    is_sun_target(float(j["gamestate"]["you"]['y']), float(j["gamestate"]["you"]['x']), float(j["gamestate"]["you"]['rotation']))

    if (int(j["gamestate"]["you"]["energy"]) > 200):
        if (r == 0):
            s.send(b"RIGHT\n")
        elif (r == 3):
            s.send(b"MINE\n")
        elif (r == 6):
            s.send(b"SEEKING\n")
        else:
            if(is_sun_target(float(j["gamestate"]["you"]['y']), float(j["gamestate"]["you"]['x']), float(j["gamestate"]["you"]['rotation']))):
                s.send(b"MINE\n")
            else:
                s.send(b"MISSILE\n")

s.close                     # Close the socket when done
